#!/usr/bin/env python2

import sys,os,re

def natural_sort(l): 
    convert = lambda text: int(text) if text.isdigit() else text.lower() 
    alphanum_key = lambda key: [ convert(c) for c in re.split('([0-9]+)', key) ] 
    return sorted(l, key = alphanum_key)

def main():
    ref=sys.argv[sys.argv.index("--ref")+1]    
    #extracting gene anotations:
    dic_genes={} #dictionnary containing the gene product in regards to the locus tag.
    r=open(ref)
    nodes=r.read().split("//\n")[:-1]
    for node in nodes:
        node_name=node.split(" ")[7]
        genes=re.findall('(     [CDScdstrnaTRNA]+             .+?/translation.+?"\n)',node.split("ORIGIN")[0],re.DOTALL)[0:]
        for gene in genes:
            locustag=(re.findall('/locus_tag="(.+)"',gene)+["/"])[0]
            product=(re.findall('/product="(.+?)"',gene,re.DOTALL)+["/"])[0].replace("\n","").replace("                     "," ")
            dic_genes[locustag]=product
    dic_genes[""]="intergenic region"


    anotation_files=sys.argv[sys.argv.index("--tsv")+1:] 
    iso_by_mutations={}
    for fil in natural_sort(anotation_files):
        f=open(fil)
        f.readline()
        for lin in f:
            spl=lin.split()
            if lin[:-1]  not in iso_by_mutations:
                iso_by_mutations[lin[:-1]]=[]
            
            iso_by_mutations[lin[:-1] ].append(fil.replace(".snpEff.tsv",""))



            
    new=open("all_mut_snpSift.tsv","w")
    for mutation in natural_sort(iso_by_mutations):
        spl=mutation.split("\t")
        if len(spl)==16: # the mutation span over several genes
            product=dic_genes[spl[-2]]+" / "+dic_genes[spl[-1]]
            new.write("\t".join(spl[0:4])+"\t"+spl[4]+","+spl[5]+"\t"+spl[6]+","+spl[7]+"\t"+spl[8]+","+spl[9]+"\t"+spl[10]+","+spl[11]+"\t"+spl[12]+","+spl[13]+"\t"+spl[14]+","+spl[15]+"\t"+product+"\t"+",".join(iso_by_mutations[mutation])+"\n")
            
        elif len(spl)==10:
            product=dic_genes[spl[-1]]
            new.write(mutation+"\t"+product+"\t"+",".join(iso_by_mutations[mutation])+"\n")

        else:
            print mutation
            print "issue with mutation: too many columns?"
            return -1
main()
