#!/usr/bin/env python2
import os, sys,re,random,time

def main():
    #Isolates groups
    WT=["2B3","1G1","7B1","8B1"]
    mutYM=["1B1a","1B1b","3B1"]
    dnaQ=["2G2","3G1","2B2a","2B2b","5G1a","5G1b","4G1a","4G1b","4G1c","4G1d","2B1","1G2","2G1","6G1a","6G1b","3G2","3G3"]

    #Recovering the gene info
    #########################
                
    #initiating dictionary containing all the genes informations
    gene_info={}

    #initiating value to collect the full seuqnce of the genome
    seq=""

    #indice to indicate wether we are in the sequence part of the gff 
    s=0
    
    #We want to recover gene informations from a gff file:
    gff=open("recons_ancestor_snippy.gff")

    #we read the file line by line and we split the elements separated by a tab into a list
    for lin in gff:
        spl=lin[:-1].split("\t")
        if lin[0]!="#": #we pass the header of the gff
            
            if lin[0]==">": #we have passed the gene informations and are entring the sequence part of the gff
                s=1
            elif s!=1: #We are still in the gene information part of the gff
                if spl[2]=="CDS": #We only look at CDSs
                    #Locus ID and gene name are recivered using regular expressions
                    name=re.findall("Name=(.+?);",spl[8])
                    ID=re.findall("ID=(.+?);",spl[8])
                    #We extract the begining (b), end (e), orientation(c) and length of the gene
                    b=int(spl[3])-1
                    e=int(spl[4])
                    c=spl[6]
                    length=e-b
                    #here we identify the gene by its name or if not available it locus ID
                    if name:
                        gene_info[name[0]]=[length,b,e,c]
                    else:
                        gene_info[ID[0]]=[length,b,e,c]
            else: #we are in the sequence part of the gff and we collect the sequence of the genome
                seq+=lin[:-1]
                


    
    #Recovering the information from the patient. Not considering complex mutations removing all shared_mut between groups
    ######################################################################################################################
    
    #initiation of dictionary containing for each gene the number of non synonymous (NS) and synonymous (S) SNVs
    mut={}
    mut_WT={}
    mut_dnaQ={}
    mut_mutYM={}

    #dictionary of the mutational spectra for each gene
    mutspectra={}

    #extracting the mutations from the annotation file
    mut_fil=open("all_mut_snpSift.tsv")
    tot_dnaQ=0
    tot_mutYM=0
    tot_WT=0
    int_dnaQ=0
    int_mutYM=0
    int_WT=0
    
    out_tot=0
    length_change=[]
    #we read the file line by line and we split the elements separated by a tab into a list
    for lin in mut_fil:
        spl=lin.replace("\n","").replace("\r","").split("\t")
        if len(spl[2])==1 and len(spl[3])==1: #we look only at substitutions to prepare for the simulation
            iso=spl[-1].split(",")
            #print iso
            #print set(iso)&set(mutYM)

            #dealing with overlapping mutations
            if "STOP_GAINED" in spl[4]:
                length_change.append(lin)
            index=0
            if "," in spl[8]: #if we have several mutations we randomly pick one to assign the mutations to
                #print lin
                index=random.choice(range(0,len(spl[8].split(","))))
            name=spl[8].split(",")[index]
            effect=spl[6].split(",")[index]
            
            if len(set(iso)&set(WT))==len(set(iso)) or len(set(iso)&set(mutYM))==len(set(iso)) or len(set(iso)&set(dnaQ))==len(set(iso)):                 
                if len(set(iso)&set(WT))>0:
                    tot_WT+=1
                    if spl[4]!="INTERGENIC":
                        #here we identify the gene by its name or if not available it locus I                                           
                        #We initiate the mut and mutspectra dictionarries for the gene in question               
                        if name not in mut_WT:
                            mut_WT[name]=0
                        mut_WT[name]+=1
                    else:
                        int_WT+=1



                if len(set(iso)&set(mutYM))>0:
                    tot_mutYM+=1
                    if spl[4]!="INTERGENIC":
                        #here we identify the gene by its name or if not available it locus I                                            
                        #We initiate the mut and mutspectra dictionarries for the gene in question               
                        if name not in mut_mutYM:
                            mut_mutYM[name]=0
                        mut_mutYM[name]+=1
                    else:
                        int_mutYM+=1
                if len(set(iso)-set(mutYM)-set(WT))>0:
                    tot_dnaQ+=1
                    if spl[4]!="INTERGENIC":
                        #here we identify the gene by its name or if not available it locus I                                            
                        #We initiate the mut and mutspectra dictionarries for the gene in question               
                        if name not in mut_dnaQ:
                            mut_dnaQ[name]=0
                        mut_dnaQ[name]+=1
                    else:
                        int_dnaQ+=1
            else:
                out_tot+=1
        elif "FRAME_SHIFT" in spl[4]:
            length_change.append(lin)
            
            
    new=open("pseudogenes.tsv","w")
    not_pseudo=0
    for mutation in length_change:
        spl=mutation.split("\t")
        index=1+spl[6].count(",") #We look if the mutation spans across mutltiuple genes and wee look at each gene independently
        for i in range(0,index): 
            if "FRAME_SHIFT" in spl[4].split(",")[i] or "STOP_GAINED" in spl[4].split(",")[i]: #in the case were there are two genes we look at wich one is concerned.
                position=re.findall("\d+",spl[6].split(",")[i])[0]
                if float(position)/float(spl[7].split(",")[i])<0.9:
                    new.write(str(float(position)/float(spl[7].split(",")[i]))+"\t"+mutation)
                else:
                    not_pseudo+=1
    print "non_pseudo length altering mutations:",not_pseudo
    new.close()
                                        


    print "tot removed",out_tot
    print "tot substitutions in Patient WT isolates", tot_WT,"(",int_WT,"intergenic)"
    print "tot substitutions in Patient dnaQ isolates", tot_dnaQ,"(",int_dnaQ,"intergenic)"
    print "tot substitutions in Patient mutYM isolates", tot_mutYM,"(",int_mutYM,"intergenic)"
    print "tot substitutions",tot_WT+tot_dnaQ+tot_mutYM
    mut_fil.close()
    


    for i in gene_info:
         if i not in mut_WT:
             mut_WT[i]=0
         if i not in mut_dnaQ:
             mut_dnaQ[i]=0
         if i not in mut_mutYM:
             mut_mutYM[i]=0
            
    

    new=open("mutation_counts_Patient_WT.txt","w")
    new.write("gene\tmutation_count\n")
    for i in mut_WT:
        new.write(i+"\t"+str(mut_WT[i])+"\n")
    new.close()

    new=open("mutation_counts_Patient_dnaQ.txt","w")
    new.write("gene\tmutation_count\n")
    for i in mut_dnaQ:
        new.write(i+"\t"+str(mut_dnaQ[i])+"\n")
    new.close()

    new=open("mutation_counts_Patient_mutYM.txt","w")
    new.write("gene\tmutation_count\n")
    for i in mut_mutYM:
        new.write(i+"\t"+str(mut_mutYM[i])+"\n")
    new.close()


main()
        
