#!/usr/bin/env python2

import os,sys,time,re

def main():
    # usage python mutspectra_from_vcf.py 1.vcf 2.vcf 3.vcf ...
    
    vcfs=sys.argv[1:] # we recover the vcfs as a list

    #dictionary used to translate the diffrerent variant types into the corresponding mutation type
    dic_snv={
        "G>T":"G:C>T:A",
        "G>C":"G:C>C:G",
        "G>A":"G:C>A:T",
        "T>G":"A:T>C:G",
        "T>C":"A:T>G:C",
        "T>A":"A:T>T:A",
        "C>G":"G:C>C:G",
        "C>T":"G:C>A:T",
        "C>A":"G:C>T:A",
        "A>G":"A:T>G:C",
        "A>T":"A:T>T:A",
        "A>C":"A:T>C:G"}

    #List to use to keep the order of the SNV constant
    snv_order=["A:T>G:C","G:C>A:T","A:T>T:A","A:T>C:G","G:C>T:A","G:C>C:G"]

    #List to use to keep the order of the isolates constant
    iso_order=['5G1b','5G1a','6G1b','2B2a','2B2b','2B1','8B1','2B3','7B1','1G1','6G1a','2G2','3G1','1B1a','1B1b','3B1','4G1d','4G1c','4G1a','4G1b','1G2','3G3','3G2','2G1']

    #dictionary of a dictionary containing for each vcf the counts for each mutation types
    dic_spectra={}
    for vcf in vcfs:
        v=open(vcf)

        #We initiate the dic_spectra for the current vcf
        dic_spectra[vcf]={"A:T>G:C":0,
        "G:C>A:T":0,
        "A:T>T:A":0,
        "A:T>C:G":0,
        "G:C>T:A":0,
        "G:C>C:G":0}
        for line in v:
            if line[0]!="#":
                spl=line.split("\t")
                if len(spl[3])==1 and len(spl[4])==1: #We only look at substitutions
                    old=spl[3] #ref allele
                    new=spl[4] #variant allele
                    dic_spectra[vcf][dic_snv[old+">"+new]]+=1  #We use the dic_snv dictionary to convert the mutation type to do the count

    #Creating the output file
    new=open("mutational_spectra.tsv","w")
    new.write("SNV\t"+"\t".join(iso_order)+"\n")
    for SNV in snv_order:
        new.write(SNV)
        for iso in iso_order:
            present=0
            for vcf in dic_spectra:
                if iso in vcf:
                    print iso,vcf
                    new.write("\t"+str(dic_spectra[vcf][SNV]))
                    present=1
                    pass
            if present!=1:
                new.write("\t0")
        new.write("\n")
    new.close()

main()
    
                
                










                
                
    
    
